# In order to draw the nice graphs please install

def iterative_live(cfg, e, i, kill, gen, tr_txt):
# cfg is dictionary of predecessor nodes in the CFG
# e is the exit vertex
# i is the initial value at the exit
# kill maps edges to set of killed variables
# gen maps edges to set of used variables
# tr_txt is the edge annotations
    wl = [e]
    lv = dict([(x, set()) for x in cfg])
    lv[e] = i
    while wl != []:
        v = wl.pop()
        print "Handling:", v
        for u in cfg[v]:
            new = lv[u] | ((lv[v] - kill[(u, v)]) | gen[(u, v)])
            if (new != lv[u]):
                print "changing the dataflow value at node:", u, "to" , new
                lv[u] = new
                wl.append(u)
                wl.sort(key=lambda x:-x) # sort in backward key order

    
    print "Dataflow results"
    for node in cfg:
           print "%s: %s"%(node, lv[node])
    import os
    f = open("temp_live.dt", "w")
    f.write("digraph cfg {\n")
    # write nodes and lv values
    for node in cfg:
        f.write("\t" + str(node) + " [label=\"lv=" + str(lv[node]) + "\"]\n")
        
    for v in cfg:
        for u in cfg[v]:
            f.write("\t" + str(u) + "->" + str(v) + " [label=\"" + tr_txt[(u,v)]+"\"]\n")
    f.write("\t}\n")
    f.close()
    os.system("dot temp_live.dt -Tpng > live.png")
    os.system("live.png")       
